<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用户昵称" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入用户昵称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="设备编码" prop="imei">
        <el-input
          v-model="queryParams.imei"
          placeholder="请输入设备编码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['user:gps:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['user:gps:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['user:gps:remove']"
        >删除</el-button>
      </el-col>
     <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['user:gps:export']"
        >导出</el-button>
      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="gpsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="用户昵称" align="center" prop="userName" />
      <el-table-column label="所属部门" align="center" prop="deptName" :show-overflow-tooltip="true"/>
      <el-table-column label="设备编码" align="center" prop="imei" />
      <el-table-column label="定位时间" align="center" prop="positionTime" width="150"/>
      <el-table-column label="定位状态" align="center" prop="status" />
      <el-table-column label="速度" align="center" prop="speed" />
      <el-table-column label="定位方式" align="center" prop="locateMethod" />
      <el-table-column label="电量" align="center" prop="electricQuan" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['user:gps:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['user:gps:remove']"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleLocation(scope.row)"
            v-hasPermi="['user:gps:current']"
          >当前位置</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleTrackHistory(scope.row)"
            v-hasPermi="['user:gps:history']"
          >历史轨迹</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改【请填写功能名称】对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="绑定用户" prop="userId">
          <!--<el-input v-model="form.userId" placeholder="请输入绑定用户" />-->
          <el-select v-model="form.userId" placeholder="请选择用户昵称" style="width: 100%">
            <el-option
              v-for="userinfo in userInfos"
              :key="userinfo.userId"
              :label="userinfo.nickName"
              :value="userinfo.userId"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="设备编码" prop="imei">
          <el-input v-model="form.imei" placeholder="请输入设备编码"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!--当前位置-->
    <CurrentLocation ref="currentLoaction"/>
    <!--历史轨迹-->
    <HistoryTrack ref="historyTracks"/>
  </div>
</template>

<script>
import { listGps, getGps, delGps, addGps, updateGps, exportGps } from "@/api/usergps/gps";
import { userInfoList } from "@/api/system/user";
import CurrentLocation from "./components/CurrentLocation";
import HistoryTrack from "./components/HistoryTrack";
import moment from 'moment';
export default {
  name: "Gps",
  components: {
    CurrentLocation,
    HistoryTrack
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      userName: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 【请填写功能名称】表格数据
      gpsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        imei: null,
        userName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userId: [
          { required: true, message: "请选择用户昵称", trigger: "change" }
        ],
        imei: [
          { required: true, message: "设备编码不能为空", trigger: "blur" },
          { pattern: '^[1-9]\\d*$', message: '请输入数字类型', trigger: 'blur' }
        ],
      },
      //用户列表
      userInfos: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询【请填写功能名称】列表 */
    getList() {
      this.loading = true;
      listGps(this.queryParams).then(response => {
        this.gpsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        userId: null,
        imei: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.userNames = selection.map(item => item.userName);
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.getUserInfo();
      this.reset();
      this.open = true;
      this.title = "添加人员设备信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.getUserInfo();
      this.reset();
      const id = row.id || this.ids
      getGps(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改人员设备信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateGps(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addGps(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const userNames = row.userName || this.userNames;
      this.$confirm('是否确认删除用户昵称为"' + userNames + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delGps(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有【请填写功能名称】数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportGps(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    /**获取用户*/
    getUserInfo(){
      userInfoList().then(res =>{
        if(res.code == 200){
          this.userInfos = res.data;
        }
      })
    },
    /**当前位置*/
    handleLocation(row){
      this.$refs.currentLoaction.openDialog(row.imei);
    },
    /**获取历史轨迹*/
    handleTrackHistory(row){
      //获取今天开始时间
      let dayOfStart = moment().startOf('day').toDate();
      //获取今天结束的时间
      let dayOfEnd = moment().endOf('day').toDate();
      this.$refs.historyTracks.openHistoryDialog({
        id:row.imei,
        startTime:moment(dayOfStart).format("YYYY-MM-DD HH:mm"),
        endTime:moment(dayOfEnd).format("YYYY-MM-DD HH:mm")
      });
    }
  }
};
</script>
